| Home | Libraries | People | FAQ | More

## Struct template is_env

boost::proto::is_env — A Boolean metafuntion for determining whether or not a type is a Proto transform environment.

## Synopsis

    // In header: <boost/proto/transform/env.hpp>

    template<typename T>
    struct is_env :  mpl::bool_<true-or-false> {
    };

## Description

`is_env<T>` inherits from `mpl::true_` under the following conditions:

- If `T` is proto::empty_env.
- If `T` is a specialization of proto::env<>.
- If `T` is derived from any of the above.
- If `T` is a cv-qualified variant of any of the above.
- If `T` is a reference to any of the above.

Otherwise, `is_env<T>` inherits from `mpl::false_`.